﻿Module Input
  EnableExplicit
  Global *Xinput
  
  Procedure Init()
    *Xinput = XInput::Xinput_Init()
  EndProcedure
  
  Procedure GetInput(*Player.Function::Tetra,*Pointer = 0)
    Protected *state.XInput::XINPUT_NORMALIZED, *Return.InputStat
    If *Pointer = 0
      *Return = AllocateMemory(SizeOf(InputStat))
    Else
      *Return = *Pointer
    EndIf
      
    If *Player
      *state = XInput::Xinput_Get(*Xinput,*Player\Inputs\Index)
      If *state = 0 : *state = AllocateMemory(SizeOf(XInput::XINPUT_NORMALIZED)) : EndIf
      ExamineKeyboard()
      If KeyboardPushed(*Player\Inputs\RotateCW) Or XInput::Xinput_Button(*state\buttons,XInput::#XINPUT_GAMEPAD_A)
        *Return\RotateCW = 1
      EndIf
      If KeyboardPushed(*Player\Inputs\RotateACW) Or XInput::Xinput_Button(*state\buttons,XInput::#XINPUT_GAMEPAD_X)
        *Return\RotateACW = 1
      EndIf
      If KeyboardPushed(*Player\Inputs\Hold) Or XInput::Xinput_Button(*state\buttons,XInput::#XINPUT_GAMEPAD_Y)
        *Return\Hold = 1
      EndIf
      If KeyboardPushed(*Player\Inputs\Up) Or *state\thumbly > 0.8 Or XInput::Xinput_Button(*state\buttons,XInput::#XINPUT_GAMEPAD_DPAD_UP)
        *Return\Up = 1
      EndIf
      If KeyboardPushed(*Player\Inputs\Left) Or *state\thumblx < -0.5 Or XInput::Xinput_Button(*state\buttons,XInput::#XINPUT_GAMEPAD_DPAD_LEFT)
        *Return\Left = 1
      EndIf
      If KeyboardPushed(*Player\Inputs\Right) Or *state\thumblx > 0.5 Or XInput::Xinput_Button(*state\buttons,XInput::#XINPUT_GAMEPAD_DPAD_RIGHT)
        *Return\Right = 1
      EndIf
      If KeyboardPushed(*Player\Inputs\Down) Or *state\thumbly < -0.5 Or XInput::Xinput_Button(*state\buttons,XInput::#XINPUT_GAMEPAD_DPAD_DOWN)
        *Return\Down = 1
      EndIf    
      If KeyboardPushed(#PB_Key_Escape)
        *Return\Start = 1
      EndIf
    Else
      *state = XInput::Xinput_Get(*Xinput,0)
      If *state = 0 : *state = AllocateMemory(SizeOf(XInput::XINPUT_NORMALIZED)) : EndIf
      ExamineKeyboard()
      If KeyboardPushed(Function::P1Up) Or KeyboardPushed(Function::P2Up) Or XInput::Xinput_Button(*state\buttons,XInput::#XINPUT_GAMEPAD_DPAD_UP)
        *Return\Up = 1
      EndIf
      If KeyboardPushed(Function::P1Down) Or KeyboardPushed(Function::P2Down) Or XInput::Xinput_Button(*state\buttons,XInput::#XINPUT_GAMEPAD_DPAD_DOWN)
        *Return\Down = 1
      EndIf
      If KeyboardPushed(#PB_Key_Return) Or KeyboardPushed(#PB_Key_Q) Or XInput::Xinput_Button(*state\buttons,XInput::#XINPUT_GAMEPAD_A) Or XInput::Xinput_Button(*state\buttons,XInput::#XINPUT_GAMEPAD_B) Or XInput::Xinput_Button(*state\buttons,XInput::#XINPUT_GAMEPAD_START) Or XInput::Xinput_Button(*state\buttons,XInput::#XINPUT_GAMEPAD_X) Or XInput::Xinput_Button(*state\buttons,XInput::#XINPUT_GAMEPAD_Y)
        *Return\Start = 1
      EndIf
      If KeyboardPushed(Function::P1Left) Or KeyboardPushed(Function::P2Left) Or XInput::Xinput_Button(*state\buttons,XInput::#XINPUT_GAMEPAD_DPAD_LEFT)
        *Return\Left = 1
      EndIf
      If KeyboardPushed(Function::P1Right) Or KeyboardPushed(Function::P2Right) Or XInput::Xinput_Button(*state\buttons,XInput::#XINPUT_GAMEPAD_DPAD_RIGHT)
        *Return\Left = 1
      EndIf
    EndIf
    ProcedureReturn *Return
  EndProcedure
  
EndModule
; IDE Options = PureBasic 5.70 LTS (Windows - x64)
; CursorPosition = 14
; FirstLine = 2
; Folding = ----
; EnableXP