﻿EnableExplicit
IncludeFile "Declare.pbi"
IncludeFile "Engine2D.pbi"
IncludeFile "EZEase.pbi"
IncludeFile "PureBF.pbi"
IncludeFile "Xinput.PBI"
IncludeFile "Function.pbi"
IncludeFile "Effects.pbi"
IncludeFile "Input.pbi"
IncludeFile "Menu.pbi"
IncludeFile "MainMenu.pbi"
IncludeFile "Settings.pbi"
IncludeFile "Options.pbi"
IncludeFile "Credit.pbi"

Enumeration
  #GS_Intro
  #GS_Menu
  #GS_Game
  #GS_Option
  #GS_Credit
EndEnumeration

InitEngine3D()
InitSprite()
InitKeyboard()
InitSound()
UsePNGImageDecoder()
UsePNGImageEncoder()
Settings::LoadSettings()
OpenWindowedScreen(WindowID(0),0,0,1280,720,#True,0,0)
AntialiasingMode(#PB_AntialiasingMode_None)
Function::LoadAssets()
Input::Init()
Options::Load()
Credit::Load()
Global GameStep = #GS_Intro, Event
Repeat
  Select GameStep
    Case #GS_Intro
      If Function::PlayIntro() : PureBF::FreeBitmapFont(Function::FontArial) : GameStep = #GS_Menu : EndIf
    Case #GS_Menu
      Event = MainMenu::Display()
      Select Event
        Case 1
          GameStep = #GS_Game
        Case 2
          GameStep = #GS_Option
        Case 3
          GameStep = #GS_Credit
      EndSelect
    Case #GS_Game
      If Function::MakeGame()
        GameStep = #GS_Menu
      EndIf
    Case #GS_Option
      If Options::Display() : GameStep = #GS_Menu : EndIf
    Case #GS_Credit
      If Credit::Display() : GameStep = #GS_Menu : EndIf
  EndSelect
  Event = WindowEvent()
  
  FlipBuffers()
Until  Event = #PB_Event_CloseWindow
; IDE Options = PureBasic 5.70 LTS (Windows - x64)
; CursorPosition = 26
; EnableXP