﻿Module Menu
  EnableExplicit
  Global SelectedElement,CurentElement
  
  Procedure ChangeElement(NewElement,Refresh = 1)
    CurentElement = SelectedElement
    SelectedElement = NewElement
    If Refresh
      EZEase::InitEase(EaseMenu)
    EndIf
  EndProcedure
  
  Procedure DisplayMenu(List Menu.s(),X,Y)
    Protected DeltaY
    If Not SelectedElement = CurentElement
      Protected Ease = EZEase::EaseResult(EaseMenu), Zoom.f
      If Ease = EZEase::#EZEase_EndEase : Ease = 0 : CurentElement = SelectedElement : zoom = 0.25 : Else : Zoom = Ease / 200  : EndIf
    Else
      Zoom = 0.25
    EndIf
    ForEach Menu()        
      If ListIndex(Menu()) = SelectedElement
        If CurentElement < SelectedElement
          DeltaY - PureBF::GetTextHeight(Function::Font,Menu(),Zoom) 
        ElseIf CurentElement > SelectedElement
          DeltaY - PureBF::GetTextHeight(Function::Font,Menu(),0.25-Zoom)
          If Not CurentElement =  1
            DeltaY - PureBF::GetTextHeight(Function::Font,Menu(),0.25)
          EndIf
        Else
          If ListIndex(Menu()) : DeltaY - PureBF::GetTextHeight(Function::Font,Menu(),0.25) : EndIf
        EndIf
        Break
      Else
        If ListIndex(Menu()) : DeltaY - PureBF::GetTextHeight(Function::Font,Menu(),0.25) : EndIf
      EndIf
    Next
    ForEach Menu()
      If ListIndex(Menu()) = CurentElement And Ease
        PureBF::DisplayText(Function::Font,X,Y+DeltaY,Menu(),0.50-Zoom,200)
        DeltaY + PureBF::GetTextHeight(Function::Font,Menu(),0.50-Zoom)
      ElseIf ListIndex(Menu()) = SelectedElement
        PureBF::DisplayText(Function::Font,X,Y,Menu(),0.25+Zoom)
        DeltaY + PureBF::GetTextHeight(Function::Font,Menu(),0.25+Zoom)
      Else
        PureBF::DisplayText(Function::Font,X,Y+DeltaY,Menu(),0.25,200)
        DeltaY + PureBF::GetTextHeight(Function::Font,Menu(),0.25)
      EndIf
    Next
    If Options::Change
      PureBF::DisplayText(Function::Font,10,600,"Please restart the game to apply change",0.3,255,#Red)
    EndIf
  EndProcedure
  
EndModule
; IDE Options = PureBasic 5.70 LTS (Windows - x64)
; CursorPosition = 50
; FirstLine = 6
; Folding = ---
; EnableXP