﻿DeclareModule Function
  Structure Inputs
    Up.d
    Down.d
    Left.d
    Right.d
    RotateCW.d
    RotateACW.d
    Hold.d
    IgnoreInput.a
    InputDelay.d
    Inputstate.a
    InputLockUP.a
    InputLockRotate.a
    InputLockHold.a
    InputStartHold.a
    Index.a
  EndStructure
  
  Structure Tetra
    X.b
    Y.b
    Score.q
    Attaque.i
    Damage.i
    Combo.f
    ScoreBox.i
    GhostY.b
    Spr.i
    Type.a
    level.a
    Line.i
    BlockX.b[4]
    BlockY.b[4]
    Rotate.a
    Effect.a
    DeltaX.i
    DeltaY.i
    OffsetX.i
    OffsetY.i
    Hold.b
    Inputs.Inputs
    List FullRow.a()
    List Distrib.a()
    Array Player1.i(10,23,1)
  EndStructure
  
  Structure TetraSpr
    Red.i
    Yellow.i
    Green.i
    Purple.i
    Blue.i
    Orange.i
    Cyan.i
    Whyte.i
    Grey.i
  EndStructure
  
  Structure EffectSpr
    BlueCircle.i
    WhiteCircle.i
    Star.i
    Ray.i
  EndStructure
  Global P1Left ,P1Right ,P1Up ,P1Down ,P1RotateClockwize ,P1RotateAntiClockwize ,P1Hold ,P2Left ,P2Right ,P2Up ,P2Down ,P2RotateClockwize ,P2RotateAntiClockwize ,P2Hold 
  Global FontArial,Font,FontShadow, PlayerMode, SprEffect.EffectSpr, SprTetra.TetraSpr, GameStat, ViewMain
  Global SndAtk1,SndAtk2,SndBreak,SndDamage,SndDeath,SndDmg1,SndDmg2,SndFall,SndMove,SndReady,SndStick,SndMusic
  Declare PlayIntro()
  Declare LoadAssets()
  Declare MakeGame()
  Declare initGame()
  Declare BreakFullRow(Player)
EndDeclareModule

DeclareModule Effects
  Structure EffectData
    X.f
    Y.f
    Value.i
  EndStructure
  
  Structure Effect
    Ease.i
    Ease2.i
    *CallBack
    *Player
    *EndEffectCallBack
    List Value.EffectData()
  EndStructure
  
  Global NewList Effects.Effect(), NewList DestroyEffect()
  
  Declare AddBreakEffect(Player)
  Declare AddFallEffect(Player)
  Declare AddTetirsEffect(Player)
  Declare AddAttaqueEffect(Player)
  Declare AddFlyEffect(Player,Start,Target)
  Declare AddDeathEffect(Player)
  Declare AddStartEffect()
  
  Declare DeleteEffect(*Effect)
  
  Declare EndEffect()
  
EndDeclareModule

DeclareModule Input
  Structure InputStat
    Up.a
    Down.a
    Left.a
    Right.a
    RotateCW.a
    RotateACW.a
    Hold.a
    Start.a
  EndStructure
  Declare Init()
  Declare GetInput(Player,*pointer=0)
EndDeclareModule

DeclareModule Menu
  Global EaseMenu
  Declare DisplayMenu(List Menu.s(),X,Y)
  Declare ChangeElement(NewElement,Refresh = 1)
EndDeclareModule

DeclareModule MainMenu
  Global LockStart, Menu
  Declare Display()
EndDeclareModule

DeclareModule Settings
  Global Width, Height,FullScreen,Path$ = GetEnvironmentVariable("APPDATA") + "\Tetirs\"
  Declare LoadSettings()
  Declare SaveSettings()
EndDeclareModule

DeclareModule Options
  Declare Load()
  Declare Display()
  Global Change
EndDeclareModule

DeclareModule Credit
  Declare Load()
  Declare Display()
EndDeclareModule
; IDE Options = PureBasic 5.70 LTS (Windows - x64)
; CursorPosition = 119
; FirstLine = 78
; Folding = --
; EnableXP