﻿Module Function
  EnableExplicit
  Enumeration ;Direction
    #PB_Left
    #PB_Right
    #PB_Down
  EndEnumeration
  
  Enumeration ;Game stat
    #GS_Play
    #GS_Pause
    #GS_Death
    #GS_Freez
  EndEnumeration
  ;{ Structures
  
  Structure Block
    BlockX.b[4]
    BlockY.b[4]
  EndStructure
  
  ;} End structures
  
  ;------------Declaration
  Global SheetTetra, BackLayer, GridLayer, DressLayer, TetraLayer, EffectLayer, SprBackGround, SprGride, SprDress, SheetBackGround, SheetDress
  Global TempoP1, TimerP1, TempoP2, TimerP2, *TetraP1.Tetra = AllocateMemory(SizeOf(Tetra)), *TetraP2.Tetra = AllocateMemory(SizeOf(Tetra))
  Global WinnerBox, LoserBox,MenuDeath,MenuPause, BoxLevel, BoxLine  
  Global NewList DistribModel(), NewList MenuDeath.s(), NewList MenuPause.s()
  Global Dim BlockMatrice.Block(6)
  InitializeStructure(*TetraP1,Tetra) : InitializeStructure(*TetraP2,Tetra)
  ;{ Menues
  AddElement(MenuDeath()): MenuDeath() = "Rematch"
  AddElement(MenuDeath()) : MenuDeath() = "Main menu"
  AddElement(MenuDeath()) : MenuDeath() = "Exit"
  AddElement(MenuPause()) : MenuPause() = "Resume"
  AddElement(MenuPause()) : MenuPause() = "Restart"
  AddElement(MenuPause()) : MenuPause() = "Main menu"
  AddElement(MenuPause()) : MenuPause() = "Exit"
  ;}
  Define i
  For i = 0 To 6
    AddElement(DistribModel())
    DistribModel() = i
  Next
  Declare DisplayScreen()    
  Declare RotateTetra(Rotation,Player)
  Declare CanMove(Player,Direction)
  Declare CanRotate(Player,Rotation)
  Declare StickTetra(Player)
  Declare NextTetra(Player)
  Declare CheckFullRow(Player)
  Declare CalcGhost(Player)
  Declare GenerateDistribList(Player)
  Declare Hold(Player)
  Declare CheckInput(Player)
  Declare UpdateScore(Player)
  Declare Attaque(Player)
  ;{ Matrice blocks
  BlockMatrice(0)\BlockX[1] = 2 : BlockMatrice(0)\BlockY[1] = 0
  BlockMatrice(0)\BlockX[2] = 1 : BlockMatrice(0)\BlockY[2] = 0
  BlockMatrice(0)\BlockX[3] = -1 : BlockMatrice(0)\BlockY[3] = 0

  BlockMatrice(1)\BlockX[1] = 1 : BlockMatrice(1)\BlockY[1] = 1
  BlockMatrice(1)\BlockX[2] = 1 : BlockMatrice(1)\BlockY[2] = 0
  BlockMatrice(1)\BlockX[3] = -1 : BlockMatrice(1)\BlockY[3] = 0
  
  BlockMatrice(2)\BlockX[0] = 0 : BlockMatrice(2)\BlockY[0] = 1
  BlockMatrice(2)\BlockX[1] = 1 : BlockMatrice(2)\BlockY[1] = 0
  BlockMatrice(2)\BlockX[2] = 1 : BlockMatrice(2)\BlockY[2] = 1
  BlockMatrice(2)\BlockX[3] = -1 : BlockMatrice(2)\BlockY[3] = 1

  BlockMatrice(3)\BlockX[1] = 1 : BlockMatrice(3)\BlockY[1] = 0
  BlockMatrice(3)\BlockX[2] = 0 : BlockMatrice(3)\BlockY[2] = 1
  BlockMatrice(3)\BlockX[3] = -1 : BlockMatrice(3)\BlockY[3] = 1

  BlockMatrice(4)\BlockX[1] = 1 : BlockMatrice(4)\BlockY[1] = 1
  BlockMatrice(4)\BlockX[2] = 0 : BlockMatrice(4)\BlockY[2] = 1
  BlockMatrice(4)\BlockX[3] = -1 : BlockMatrice(4)\BlockY[3] = 0
  
  BlockMatrice(5)\BlockX[0] = 0 : BlockMatrice(5)\BlockY[0] = 1
  BlockMatrice(5)\BlockX[1] = -1 : BlockMatrice(5)\BlockY[1] = 1
  BlockMatrice(5)\BlockX[2] = 1 : BlockMatrice(5)\BlockY[2] = 1
  BlockMatrice(5)\BlockX[3] = 0 : BlockMatrice(5)\BlockY[3] = 0

  BlockMatrice(6)\BlockX[1] = 1 : BlockMatrice(6)\BlockY[1] = 1
  BlockMatrice(6)\BlockX[2] = 1 : BlockMatrice(6)\BlockY[2] = 0
  BlockMatrice(6)\BlockX[3] = 0 : BlockMatrice(6)\BlockY[3] = 1
  ;}
  
;------------Macros
  Macro MakeTetra(Player)
    Select Player\Type
      Case 0
        Player\BlockX[1] = 0 : Player\BlockY[1] = -2
        Player\BlockX[2] = 0 : Player\BlockY[2] = -1
        Player\BlockX[3] = 0 : Player\BlockY[3] = 1
      Case 1
        Player\BlockX[1] = 1 : Player\BlockY[1] = -1
        Player\BlockX[2] = 0 : Player\BlockY[2] = -1
        Player\BlockX[3] = 0 : Player\BlockY[3] = 1
      Case 2
        Player\BlockX[1] = -1 : Player\BlockY[1] = -1
        Player\BlockX[2] = 0 : Player\BlockY[2] = -1
        Player\BlockX[3] = 0 : Player\BlockY[3] = 1
      Case 3
        Player\BlockX[1] = 0 : Player\BlockY[1] = -1
        Player\BlockX[2] = 1 : Player\BlockY[2] = 0
        Player\BlockX[3] = 1 : Player\BlockY[3] = 1
      Case 4
        Player\BlockX[1] = 1 : Player\BlockY[1] = -1
        Player\BlockX[2] = 1 : Player\BlockY[2] = 0
        Player\BlockX[3] = 0 : Player\BlockY[3] = 1
      Case 5
        Player\BlockX[1] = -1 : Player\BlockY[1] = 0
        Player\BlockX[2] = 1 : Player\BlockY[2] = 0
        Player\BlockX[3] = 0 : Player\BlockY[3] = -1
      Case 6
        Player\BlockX[1] = 1 : Player\BlockY[1] = -1
        Player\BlockX[2] = 1 : Player\BlockY[2] = 0
        Player\BlockX[3] = 0 : Player\BlockY[3] = -1
    EndSelect
  EndMacro
  
  Macro DisplayMacro(Player)
    Sprite3D::DisplaySprite3D(SprDress,Player\DeltaX-148,Player\DeltaY- 25)
    ;Display game gride
    For LoopY = 0 To 19
      For LoopX = 0 To 9
        If Player\Player1(LoopX,LoopY+3,0)
          If LoopY = 19
            If Player\Player1(LoopX,LoopY+3,1)
              Sprite3D::ZoomSprite3D(Player\Player1(LoopX,LoopY+3,0),26,26-Player\Player1(LoopX,LoopY+3,1))
              Zoom = 1
            EndIf
          EndIf
          Sprite3D::DisplaySprite3D(Player\Player1(LoopX,LoopY+3,0),26*LoopX+ Player\DeltaX + Player\OffsetX,26*(LoopY)+ Player\DeltaY + Player\OffsetY+ Player\Player1(LoopX,LoopY+3,1))
          If Zoom
            Sprite3D::ZoomSprite3D(Player\Player1(LoopX,LoopY+3,0),26,26)
            Zoom = 0
          EndIf
        EndIf
      Next
    Next
    ;Display curent tetra and ghost
    If GameStat = #GS_Play
      For loopX = 0 To 3
        If (Player\Y+Player\BlockY[loopX]) >= 3
          Sprite3D::DisplaySprite3D(Player\Spr,(Player\X+Player\BlockX[loopX])*26+ Player\DeltaX,(Player\Y-3+Player\BlockY[loopX])*26+ Player\DeltaY)
        EndIf
        If Player\GhostY > 4
          If PlayerMode = 1
            Sprite3D::DisplaySprite3D(Player\Spr,(Player\X+Player\BlockX[loopX])*26+ Player\DeltaX,(Player\GhostY-3+Player\BlockY[loopX])*26+ Player\DeltaY,120)
          Else
            Sprite3D::DisplaySprite3D(Player\Spr,(Player\X+Player\BlockX[loopX])*26+ Player\DeltaX,(Player\GhostY-3+Player\BlockY[loopX])*26+ Player\DeltaY,150)
          EndIf
        EndIf
      Next
    EndIf
    ;Display Tetra queue
    For LoopX = 0 To 4
      If Player\Hold <> -1 And LoopX <4
        If Player\Hold = 0 Or Player\Hold = 6
          Sprite3D::DisplaySprite3D(PeekI(@SprTetra + SizeOf(integer) * Player\Hold), Player\DeltaX - 105 + BlockMatrice(Player\Hold)\BlockX[LoopX]*26,Player\DeltaY + 95 + BlockMatrice(Player\Hold)\BlockY[LoopX]*26)
        Else
          Sprite3D::DisplaySprite3D(PeekI(@SprTetra + SizeOf(integer) * Player\Hold), Player\DeltaX - 95 + BlockMatrice(Player\Hold)\BlockX[LoopX]*26,Player\DeltaY + 95 + BlockMatrice(Player\Hold)\BlockY[LoopX]*26)
        EndIf
      EndIf
      Sprite3D::ZoomSprite3D(PeekI(@SprTetra + SizeOf(integer)* Player\Distrib()),15,15)
      For LoopY = 0 To 3
        Sprite3D::DisplaySprite3D(PeekI(@SprTetra + SizeOf(integer)* Player\Distrib()),Player\DeltaX + 330 + BlockMatrice(Player\Distrib())\BlockX[LoopY]*15,(Player\DeltaY + 70) + (60 * Bool(LoopX > 0)) + 70*LoopX +BlockMatrice(Player\Distrib())\BlockY[LoopY]*15)
      Next
      Sprite3D::ZoomSprite3D(PeekI(@SprTetra + SizeOf(integer)* Player\Distrib()),26,26)
      NextElement(Player\Distrib())
    Next
    ;Display Player's incoming damage
    TempDamage = Player\Damage : DamageX = 0
    If Player\Damage
      While TempDamage
        If TempDamage > 5
          Sprite3D::ZoomSprite3D(SprTetra\Grey,35,35)
          Sprite3D::DisplaySprite3D(SprTetra\Grey,Player\DeltaX+DamageX,55)
          Sprite3D::ZoomSprite3D(SprTetra\Grey,26,26)
          TempDamage - 5
          DamageX + 40
        Else
          Sprite3D::RotateSprite3D(SprTetra\Grey,45)
          Sprite3D::DisplaySprite3D(SprTetra\Grey,Player\DeltaX+DamageX,55)
          Sprite3D::RotateSprite3D(SprTetra\Grey,0)
          TempDamage - 1
          DamageX + 30
        EndIf
      Wend  
    EndIf
    FirstElement(Player\Distrib())
  EndMacro
  
  Macro Valid()
    ElseIf GameStat = #GS_Pause
      Select MenuPause
        Case 0
          GameStat = #GS_Play
        Case 1
          initGame()
        Case 2
          MainMenu::LockStart = 1
          GameStat = #GS_Play
          MainMenu::Menu = 0
          Menu::ChangeElement(MainMenu::Menu,0)
          ProcedureReturn #True
        Case 3
          End
      EndSelect
    ElseIf GameStat = #GS_Death
      Select MenuDeath
        Case 0
          initGame()
;           GameStat = #GS_Play
        Case 1
          MainMenu::LockStart = 1
          GameStat = #GS_Play
          MainMenu::Menu = 0
          Menu::ChangeElement(MainMenu::Menu,0)
          ProcedureReturn #True
        Case 2
          End
      EndSelect
  EndMacro
    
  ;-----------Public procedure
  Procedure PlayIntro() 
    Static IntroStep, Tempo, TimePassed
    If IntroStep = 0 : Tempo = ElapsedMilliseconds() : IntroStep = 1 : ProcedureReturn #False : EndIf
    Sprite3D::RenderSprite()
    ExamineKeyboard()
    If KeyboardPushed(#PB_Key_Escape) : ProcedureReturn #True : EndIf
    TimePassed = ElapsedMilliseconds() - Tempo
    Select IntroStep
      Case 1
        Select TimePassed
          Case 0 To 300
            PureBF::DisplayText(FontArial,610,0,"T")
          Case 300 To 600
            PureBF::DisplayText(FontArial,552,0,"T")
          Case 600 To 900
            PureBF::DisplayText(FontArial,552,306,"T")
          Default
            PureBF::DisplayText(FontArial,552,306,"T")
            IntroStep = 2 : Tempo = ElapsedMilliseconds()
        EndSelect
      Case 2
        Select TimePassed
          Case 0 To 300
            PureBF::DisplayText(FontArial,610,0,"R",1,255,#PB_Default,180)
          Case 300 To 450
            PureBF::DisplayText(FontArial,610,0,"R",1,255,#PB_Default,90)
          Case 450 To 600
            PureBF::DisplayText(FontArial,610,0,"R",1,255,#PB_Default,0)  
          Case 600 To 900
            PureBF::DisplayText(FontArial,638,0,"R",1,255,#PB_Default,0)
          Case 900 To 1200
            PureBF::DisplayText(FontArial,638,306,"R",1,255,#PB_Default,0)
          Default
            PureBF::DisplayText(FontArial,638,306,"R",1,255,#PB_Default,0)
            IntroStep = 3 : Tempo = ElapsedMilliseconds()
        EndSelect
        PureBF::DisplayText(FontArial,552,306,"T")
      Case 3
        Select TimePassed
          Case 0 To 300
            PureBF::DisplayText(FontArial,610,0,"T",1,255,#PB_Default,270)
          Case 300 To 450
            PureBF::DisplayText(FontArial,520,0,"T",1,255,#PB_Default,270)
          Case 450 To 600
            PureBF::DisplayText(FontArial,429,0,"T",1,255,#PB_Default,270)
          Case 600 To 750
            PureBF::DisplayText(FontArial,429,107,"T",1,255,#PB_Default,270)
          Case 750 To 900
            PureBF::DisplayText(FontArial,429,107,"T")
          Case 900 To 1200
            PureBF::DisplayText(FontArial,429,306,"T")
          Default
            PureBF::DisplayText(FontArial,429,306,"T")
            IntroStep = 4 : Tempo = ElapsedMilliseconds()
        EndSelect
        PureBF::DisplayText(FontArial,552,306,"T")
        PureBF::DisplayText(FontArial,638,306,"R")
      Case 4
        Select TimePassed
          Case 0 To 300
            PureBF::DisplayText(FontArial,610,0,"I")
          Case 300 To 600
            PureBF::DisplayText(FontArial,610,306,"I")
          Default
            PureBF::DisplayText(FontArial,610,306,"I")
            IntroStep = 5 : Tempo = ElapsedMilliseconds()
        EndSelect
        PureBF::DisplayText(FontArial,429,306,"T")
        PureBF::DisplayText(FontArial,552,306,"T")
        PureBF::DisplayText(FontArial,638,306,"R")
      Case 5
        Select TimePassed
          Case 0 To 300
            PureBF::DisplayText(FontArial,610,0,"E",1,255,#PB_Default,90)
          Case 0 To 450
            PureBF::DisplayText(FontArial,488,0,"E",1,255,#PB_Default,90)
          Case 0 To 600
            PureBF::DisplayText(FontArial,488,0,"E")
          Case 600 To 900
            PureBF::DisplayText(FontArial,488,306,"E")
          Default
            PureBF::DisplayText(FontArial,488,306,"E")
            IntroStep = 6 : Tempo = ElapsedMilliseconds()
        EndSelect
        PureBF::DisplayText(FontArial,429,306,"T")
        PureBF::DisplayText(FontArial,552,306,"T")
        PureBF::DisplayText(FontArial,610,306,"I")
        PureBF::DisplayText(FontArial,638,306,"R") 
      Case 6 
        Select TimePassed
          Case 0 To 300
            PureBF::DisplayText(FontArial,610,0,"S")
          Case 300 To 600
            PureBF::DisplayText(FontArial,707,0,"S")
          Case 600 To 900
            PureBF::DisplayText(FontArial,707,306,"S")
          Default
            PureBF::DisplayText(FontArial,707,306,"S")
            IntroStep = 7 : Tempo = ElapsedMilliseconds()
        EndSelect        
        PureBF::DisplayText(FontArial,429,306,"TETIR")
      Case 7
        Select TimePassed
          Case 0 To 300
            PureBF::DisplayText(FontArial,610,0,"2",1,255,#PB_Default,180)
          Case 300 To 450
            PureBF::DisplayText(FontArial,520,0,"2",1,255,#PB_Default,180)
          Case 450 To 600
            PureBF::DisplayText(FontArial,429,0,"2",1,255,#PB_Default,180)
          Case 600 To 750
            PureBF::DisplayText(FontArial,520,107,"2",1,255,#PB_Default,180)
          Case 750 To 900
            PureBF::DisplayText(FontArial,610,107,"2",1,255,#PB_Default,180)
          Case 900 To 1050
            PureBF::DisplayText(FontArial,700,107,"2",1,255,#PB_Default,180)
          Case 1050 To 1200
            PureBF::DisplayText(FontArial,798,107,"2",1,255,#PB_Default,180)
          Case 1200 To 1350
            PureBF::DisplayText(FontArial,798,190,"2",1,255,#PB_Default,90)
          Case 1350 To 1500
            PureBF::DisplayText(FontArial,798,190,"2")
            Case 1500 To 1700
            PureBF::DisplayText(FontArial,798,306,"2")
          Default
            PureBF::DisplayText(FontArial,798,306,"2")
            IntroStep = 8 : Tempo = ElapsedMilliseconds()
        EndSelect
        PureBF::DisplayText(FontArial,429,306,"TETIRS")
      Case 8
        Select TimePassed
          Case 300 To 600
            PureBF::DisplayText(FontArial,429,306,"TETIRS 2")
          Case 900 To 1200
            PureBF::DisplayText(FontArial,429,306,"TETIRS 2")
          Case 1500 To 1800
            PureBF::DisplayText(FontArial,429,306,"TETIRS 2")
          Case 1800 To 3000
            ProcedureReturn #True
        EndSelect
    EndSelect
  EndProcedure
  
  Procedure LoadAssets()
    Protected loop
    ViewMain = Sprite3D::CreateView()
    FontArial = PureBF::LoadBitmapFont("Media/Arial.afg",ViewMain)
    PureBF::DisplayText(FontArial,430,307,"Loading...")
    Sprite3D::RenderSprite()
    FlipBuffers()
    SheetTetra = Sprite3D::LoadSpriteSheet("Media/Sheet.png")
    SheetBackGround = Sprite3D::LoadSpriteSheet("Media/Background.png")
    SheetDress = Sprite3D::LoadSpriteSheet("Media/Gride.png")
    BackLayer = Sprite3D::CreateLayer(ViewMain,SheetBackGround,1,1)
    DressLayer = Sprite3D::CreateLayer(ViewMain,SheetDress,1,3)
    TetraLayer = Sprite3D::CreateLayer(ViewMain,SheetTetra,1,4)
    EffectLayer = Sprite3D::CreateLayer(ViewMain,SheetTetra,1,5)
    For loop = 0 To 6
      PokeI(@SprTetra+loop*SizeOf(integer),Sprite3D::CreateSprite3D(50,50,TetraLayer))
      Sprite3D::ClipSprite3D(PeekI(@SprTetra+loop*SizeOf(integer)),loop*50,0,50,50)
      Sprite3D::ZoomSprite3D(PeekI(@SprTetra+loop*SizeOf(integer)),26,26)
    Next
    For loop = 0 To 3
      PokeI(@SprEffect+loop*SizeOf(integer),Sprite3D::CreateSprite3D(50,50,EffectLayer))
      Sprite3D::ClipSprite3D(PeekI(@SprEffect+loop*SizeOf(integer)),(loop+3)*50,50,50,50)
      Sprite3D::ZoomSprite3D(PeekI(@SprEffect+loop*SizeOf(integer)),26,26)
    Next
    SprTetra\Whyte = Sprite3D::CreateSprite3D(50,50,TetraLayer)
    Sprite3D::ClipSprite3D(SprTetra\Whyte,100,50,50,50)
    Sprite3D::ZoomSprite3D(SprTetra\Whyte,26,26)
    SprTetra\Grey = Sprite3D::CreateSprite3D(50,50,TetraLayer)
    Sprite3D::ClipSprite3D(SprTetra\Grey,50,50,50,50)
    Sprite3D::ZoomSprite3D(SprTetra\Grey,26,26)
    SprBackGround = Sprite3D::CreateSprite3D(1280,720,BackLayer)
    SprDress = Sprite3D::CreateSprite3D(555,641,DressLayer)
    Sprite3D::ClipSprite3D(SprDress,24,0,555,641)
    Font = PureBF::LoadBitmapFont("Media/Henny Penny.afg",ViewMain)
    FontShadow = PureBF::LoadBitmapFont("Media/Henny Penny Shadow.afg",ViewMain)
    WinnerBox = PureBF::CreateTextBox(0,0,290,200,#PB_Text_Center)
    LoserBox = PureBF::CreateTextBox(0,0,290,200,#PB_Text_Center)
    PureBF::SetWaveAttribut(0.2,10)
    PureBF::AddTextBoxString(WinnerBox,Font,"${wave} WINNER",0.5,255,RGB(255,28,50))
    PureBF::AddTextBoxString(LoserBox,Font,"LOSER",0.5,255,RGB(30,90,255))
    BoxLine = PureBF::CreateTextBox(300,340,160,60,#PB_Text_Right)
    BoxLevel = PureBF::CreateTextBox(300,440,160,60,#PB_Text_Right)
    Menu::EaseMenu = EZEase::CreateEase(EZEase::#EZEase_easeOutCubic,0,50,200)
    SndAtk1 = LoadSound(#PB_Any,"Media/Snd/Atk1.wav")
    SndAtk2 = LoadSound(#PB_Any,"Media/Snd/Atk2.wav")
    SndBreak = LoadSound(#PB_Any,"Media/Snd/Break.wav")
    SndDamage = LoadSound(#PB_Any,"Media/Snd/Damage.wav")
    SndDeath = LoadSound(#PB_Any,"Media/Snd/Death.wav")
    SndDmg1 = LoadSound(#PB_Any,"Media/Snd/Dmg1.wav")
    SndDmg2 = LoadSound(#PB_Any,"Media/Snd/Dmg2.wav")
    SndFall = LoadSound(#PB_Any,"Media/Snd/Fall.wav")
    SndMove = LoadSound(#PB_Any,"Media/Snd/Move.wav")
    SndReady = LoadSound(#PB_Any,"Media/Snd/Ready.wav")
    SndStick = LoadSound(#PB_Any,"Media/Snd/Stick.wav")
    SndMusic = LoadSound(#PB_Any,"Media/Snd/Tetris.wav")
    SoundVolume(SndMusic,50)
    SoundVolume(SndDamage,70)
    SoundVolume(SndMove,50)
  EndProcedure
  
  Procedure initGame()
    Protected i,j
    For i = 0 To 23
      For j = 0 To 10
        *TetraP1\Player1(j,i,0) = 0
        *TetraP2\Player1(j,i,0) = 0
      Next
    Next
    ClearList(*TetraP1\Distrib())
    ClearList(*TetraP2\Distrib())
    ClearList(Effects::Effects())
    ClearList(Effects::DestroyEffect())
    GenerateDistribList(*TetraP1)
    GenerateDistribList(*TetraP1)
    FirstElement(*TetraP1\Distrib())
    TempoP1 = 1000 : TempoP2 = 1000
    TimerP1 = ElapsedMilliseconds() : TimerP2 = TimerP1
    *TetraP1\Inputs\Index = 0 : *TetraP2\Inputs\Index = 1
    *TetraP1\Score = 0 : *TetraP2\Score = 0
    *TetraP1\level = 0 : *TetraP2\level = 0
    NextTetra(*TetraP1)
    *TetraP1\Hold = -1
    *TetraP1\Attaque = 0 : *TetraP1\Combo = 0 : *TetraP1\Damage = 0
    *TetraP2\Attaque = 0 : *TetraP2\Combo = 0 : *TetraP2\Damage = 0
    *TetraP1\Line = 0 : *TetraP2\Line = 0
    If PlayerMode = 1
      *TetraP1\DeltaX = 500 : *TetraP1\DeltaY = 100
;       *TetraP1\Inputs\Down = P1Down
;       *TetraP1\Inputs\Hold = P1Hold
;       *TetraP1\Inputs\Left = P1Left
;       *TetraP1\Inputs\Right = P1Right
;       *TetraP1\Inputs\RotateACW = P1RotateAntiClockwize
;       *TetraP1\Inputs\RotateCW = P1RotateClockwize
;       *TetraP1\Inputs\Up = P1Up
      UpdateScore(*TetraP1)
      PureBF::FreeTextBox(BoxLine)
      BoxLine = PureBF::CreateTextBox(300,340,160,60,#PB_Text_Right)
      PureBF::AddTextBoxString(BoxLine,Font,Str(*TetraP1\Line),0.33,255)
      PureBF::FreeTextBox(BoxLevel)
      BoxLevel = PureBF::CreateTextBox(300,440,160,60,#PB_Text_Right)
      PureBF::AddTextBoxString(BoxLevel,Font,Str(*TetraP1\level),0.33,255)
    Else
      *TetraP1\DeltaX = 150 : *TetraP1\DeltaY = 100
      *TetraP2\DeltaX = 800 : *TetraP2\DeltaY = 100
      GenerateDistribList(*TetraP2)
      GenerateDistribList(*TetraP2)
      FirstElement(*TetraP2\Distrib())
      NextTetra(*TetraP2)
;       *TetraP1\Inputs\Down = P1Down
;       *TetraP1\Inputs\Hold = P1Hold
;       *TetraP1\Inputs\Left = P1Left
;       *TetraP1\Inputs\Right = P1Right
;       *TetraP1\Inputs\RotateACW = P1RotateAntiClockwize
;       *TetraP1\Inputs\RotateCW = P1RotateClockwize
;       *TetraP1\Inputs\Up = P1Up
;       *TetraP2\Hold = -1
;       *TetraP2\Inputs\Down = P2Down
;       *TetraP2\Inputs\Hold = P2Hold
;       *TetraP2\Inputs\Left = P2Left
;       *TetraP2\Inputs\Right = P2Right
;       *TetraP2\Inputs\RotateACW = P2RotateAntiClockwize
;       *TetraP2\Inputs\RotateCW = P2RotateClockwize
;       *TetraP2\Inputs\Up = P2Up
      UpdateScore(*TetraP1)
      UpdateScore(*TetraP2)
    EndIf
      *TetraP1\Inputs\Down = P1Down
      *TetraP1\Inputs\Hold = P1Hold
      *TetraP1\Inputs\Left = P1Left
      *TetraP1\Inputs\Right = P1Right
      *TetraP1\Inputs\RotateACW = P1RotateAntiClockwize
      *TetraP1\Inputs\RotateCW = P1RotateClockwize
      *TetraP1\Inputs\Up = P1Up
      *TetraP2\Hold = -1
      *TetraP2\Inputs\Down = P2Down
      *TetraP2\Inputs\Hold = P2Hold
      *TetraP2\Inputs\Left = P2Left
      *TetraP2\Inputs\Right = P2Right
      *TetraP2\Inputs\RotateACW = P2RotateAntiClockwize
      *TetraP2\Inputs\RotateCW = P2RotateClockwize
      *TetraP2\Inputs\Up = P2Up
    *TetraP1\ScoreBox = PureBF::CreateTextBox(*TetraP1\DeltaX,620,260,100,#PB_Text_Right)
    *TetraP2\ScoreBox = PureBF::CreateTextBox(*TetraP2\DeltaX,620,260,100,#PB_Text_Right)
    GameStat = #GS_Freez
    Effects::AddStartEffect()
    PlaySound(SndReady)
  EndProcedure  
  
  Procedure MakeGame()
    If GameStat = #GS_Play
      If ElapsedMilliseconds() - TimerP1 >= TempoP1
        If CanMove(*TetraP1,#PB_Down)
          *TetraP1\Y + 1 
        Else
          If StickTetra(*TetraP1)
            CheckFullRow(*TetraP1)
            NextTetra(*TetraP1)
            UpdateScore(*TetraP1)
          EndIf
        EndIf
        TimerP1 = ElapsedMilliseconds()
      EndIf
      If PlayerMode = 2
        If ElapsedMilliseconds() - TimerP2 >= TempoP2
          If CanMove(*TetraP2,#PB_Down)
            *TetraP2\Y + 1 
          Else
            If StickTetra(*TetraP2)
              CheckFullRow(*TetraP2)
              NextTetra(*TetraP2)
              UpdateScore(*TetraP2)
            EndIf
          EndIf
          TimerP2 = ElapsedMilliseconds()
        EndIf
      EndIf
      
    EndIf
    
    If CheckInput(*TetraP1)
      StopSound(SndMusic)
      ProcedureReturn #True
    EndIf
    If PlayerMode = 2
      CheckInput(*TetraP2)
    EndIf
    
    
    DisplayScreen()
  EndProcedure
  
  
  ;------------Private procedure
  
  Procedure CheckInput(*Player.Tetra)
    Protected *Input.Input::InputStat
    *Input = Input::GetInput(*Player)
    If PlayerMode = 1
      *Input = Input::GetInput(*TetraP2,*Input)
    EndIf
    If *Input\RotateCW
      If *Player\Inputs\InputLockRotate = 0
        If GameStat = #GS_Play And *Player\Inputs\IgnoreInput = 0
          If CanRotate(*Player,1)
            RotateTetra(1,*Player)
            CalcGhost(*Player)
          EndIf
          Valid()
        EndIf
        *Player\Inputs\InputLockRotate = 1
      EndIf
    EndIf
    
    If *Input\RotateACW
      If *Player\Inputs\InputLockRotate = 0
        If GameStat = #GS_Play And *Player\Inputs\IgnoreInput = 0
          If CanRotate(*Player,0)
            RotateTetra(0,*Player)
            CalcGhost(*Player)
          EndIf
          Valid()
        EndIf
        *Player\Inputs\InputLockRotate = 1
      EndIf
    EndIf
    
    If *Input\Hold
      If *Player\Inputs\InputLockHold = 0
        If GameStat = #GS_Play And *Player\Inputs\IgnoreInput = 0
          Hold(*Player)
          Valid()
        EndIf
        *Player\Inputs\InputLockHold = 1
      EndIf
    EndIf
               
    If *Input\Left
      If GameStat = #GS_Play And *Player\Inputs\IgnoreInput = 0
        If *Player\Inputs\Inputstate = 2
          ProcedureReturn #False
        EndIf
        If *Player\Inputs\Inputstate
          If ElapsedMilliseconds() - *Player\Inputs\InputDelay >= 100
            *Player\Inputs\InputDelay = ElapsedMilliseconds()
          Else
            ProcedureReturn #False
          EndIf
        Else
          *Player\Inputs\Inputstate = 1
          *Player\Inputs\InputDelay = ElapsedMilliseconds() +200
        EndIf
        If CanMove(*Player,#PB_Left)
          *Player\X -1
          CalcGhost(*Player)
        EndIf
      EndIf
    EndIf
    
    If *Input\Right
      If GameStat = #GS_Play And *Player\Inputs\IgnoreInput = 0
        If *Player\Inputs\Inputstate = 2
          ProcedureReturn #False
        EndIf
        If *Player\Inputs\Inputstate
          If ElapsedMilliseconds() - *Player\Inputs\InputDelay >= 100
            *Player\Inputs\InputDelay = ElapsedMilliseconds()
          Else
            ProcedureReturn #False
          EndIf
        Else
          *Player\Inputs\Inputstate = 1
          *Player\Inputs\InputDelay = ElapsedMilliseconds() +200
        EndIf
        If CanMove(*Player,#PB_Right)
          *Player\X +1
          CalcGhost(*Player)
        EndIf
      EndIf
    EndIf     
    
    If *Input\Down And *Player\Inputs\Inputstate = 0
      If GameStat = #GS_Play And *Player\Inputs\IgnoreInput = 0
;         If *Player\Inputs\IgnoreInput = 0
          If *Player\Inputs\Inputstate = 2
            ProcedureReturn
          EndIf
;           *Player\Inputs\Inputstate = 1
          If CanMove(*Player,#PB_Down)
            *Player\Y + 1
            If *Player = *TetraP1
              TimerP1 = ElapsedMilliseconds()
            Else
              TimerP2 = ElapsedMilliseconds()
            EndIf
          EndIf
;         EndIf
      ElseIf GameStat = #GS_Death
        If MenuDeath < 2 : MenuDeath + 1 : Menu::ChangeElement(MenuDeath) : EndIf
        *Player\Inputs\Inputstate = 1
      ElseIf GameStat = #GS_Pause
        If MenuPause < 3 : MenuPause + 1 : Menu::ChangeElement(MenuPause) : EndIf
        *Player\Inputs\Inputstate = 1
      EndIf    
    EndIf
    
    If *Input\Up And *Player\Inputs\InputLockUP = 0 
      If GameStat = #GS_Play And *Player\Inputs\IgnoreInput = 0
        If *Player\Inputs\InputLockUP = 0
          *Player\Score + ((*Player\GhostY - *Player\Y)*2)
          *Player\Y = *Player\GhostY
          Effects::AddFallEffect(*Player)
          StickTetra(*Player)
          CheckFullRow(*Player)
          UpdateScore(*Player)
          NextTetra(*Player)
        EndIf
      ElseIf GameStat = #GS_Death
        If MenuDeath : MenuDeath - 1 : Menu::ChangeElement(MenuDeath) : EndIf
      ElseIf GameStat = #GS_Pause
        If MenuPause : MenuPause - 1 : Menu::ChangeElement(MenuPause) : EndIf
      EndIf
      *Player\Inputs\InputLockUP = 1
    EndIf 
      
    If *Input\Start
      If *TetraP1\Inputs\InputStartHold = 0
        If GameStat = #GS_Play
          ForEach Effects::Effects()
            EZEase::PauseEase(Effects::Effects()\Ease)
            If Effects::Effects()\Ease2 : EZEase::PauseEase(Effects::Effects()\Ease2) : EndIf
          Next
          MenuPause = 0
          Menu::ChangeElement(MenuPause,0)
          GameStat = #GS_Pause
        ElseIf GameStat = #GS_Pause
          ForEach Effects::Effects()
            EZEase::ResumeEase(Effects::Effects()\Ease)
            If Effects::Effects()\Ease2 : EZEase::ResumeEase(Effects::Effects()\Ease2) : EndIf
          Next
          GameStat = #GS_Play
        EndIf
        *TetraP1\Inputs\InputStartHold = 1
      EndIf
    EndIf
      
      
    ;Relase inputes
    If *Input\Down + *Input\Left + *Input\Right = 0
      *Player\Inputs\Inputstate = 0
    EndIf
    
    If *Input\Up = 0
      *Player\Inputs\InputLockUP = 0
    EndIf
    
    If *Input\Hold = 0
      *Player\Inputs\InputLockHold = 0
    EndIf
    
    If *Input\RotateACW + *Input\RotateCW = 0
      *Player\Inputs\InputLockRotate = 0
    EndIf

    If *Input\Start = 0
      *Player\Inputs\InputStartHold = 0
    EndIf
    
  EndProcedure
  
  Procedure UpdateScore(*Player.Tetra)
    Protected Zoom.f = 0.7
    While PureBF::GetTextWidth(Font,Str(*Player\Score),Zoom) > 249
      Zoom - 0.1
    Wend
    PureBF::FreeTextBox(*Player\ScoreBox)
    *Player\ScoreBox = PureBF::CreateTextBox(*Player\DeltaX,615,260,100,#PB_Text_Right)
    PureBF::AddTextBoxString(*Player\ScoreBox,FontShadow,Str(*Player\Score),Zoom,255)
  EndProcedure
  
  Procedure DisplayScreen()
    Protected LoopX, LoopY,Zoom,TempDamage, DamageX
    Static X.a
    Sprite3D::DisplaySprite3D(SprBackGround,0,0)
    If PlayerMode = 1
      ;Display P1
      DisplayMacro(*TetraP1)

    Else
      ;Display P2
      DisplayMacro(*TetraP1)
      DisplayMacro(*TetraP2)      
    EndIf
    PureBF::DisplayTextBox(*TetraP1\ScoreBox)
    If PlayerMode = 2
      PureBF::DisplayTextBox(*TetraP2\ScoreBox)
    EndIf
    ForEach Effects::Effects()
      CallFunctionFast(Effects::Effects()\CallBack)
    Next
    Effects::EndEffect()
    If PlayerMode = 1
      ;Display Score & level
      PureBF::DisplayText(Font,380,280,"Line",0.33,255)
      PureBF::DisplayTextBox(BoxLine)
      PureBF::DisplayText(Font,380,380,"Level",0.33,255)
      PureBF::DisplayTextBox(BoxLevel)
    EndIf
    If GameStat = #GS_Death 
      If PlayerMode = 2
        PureBF::MoveTextBox(LoserBox,0,2 * Sin(2 * #PI / 51 * X),#PB_Relative)
        X + 1
        PureBF::DisplayTextBox(WinnerBox)
        PureBF::DisplayTextBox(LoserBox)
      EndIf
      Menu::DisplayMenu(MenuDeath(),550,300)
    ElseIf GameStat = #GS_Pause
      PureBF::DisplayText(Font,381,10,"Game pause")
      Menu::DisplayMenu(MenuPause(),550,300)
    EndIf
    
    
    Sprite3D::RenderSprite()
  EndProcedure
  
  Procedure RotateTetra(Rotation,*Player.Tetra)
    Protected i, X,Offset
    If *Player\Type = 3 Or *Player\Type = 4 Or *Player\Type = 0
      Rotation = 1
      Rotation ! *Player\Rotate
      *Player\Rotate = Rotation
    EndIf
    If Rotation
      For i = 1 To 3
        X = - *Player\BlockY[i]
        *Player\BlockY[i] = *Player\BlockX[i]
        *Player\BlockX[i] = X
        If *Player\X + X > 9
          If Offset = 0
            Offset = *Player\X + X - 9
          EndIf
        ElseIf *Player\X + x < 0
          If Offset = 0
            Offset = *Player\X + X
          EndIf
        EndIf
      Next
    Else
      For i = 1 To 3
        X = *Player\BlockY[i]
        *Player\BlockY[i] = - *Player\BlockX[i]
        *Player\BlockX[i] = X
        If *Player\X + X > 9
          If Offset = 0
            Offset = *Player\X + X - 9
          EndIf
        ElseIf *Player\X + x < 0
          If Offset = 0
            Offset = *Player\X + X
          EndIf
        EndIf
      Next
    EndIf
    *Player\X + -Offset
  EndProcedure
  
  Procedure CanMove(*Player.Tetra,Direction)
    Protected i
    Select Direction
      Case #PB_Left
        For i = 0 To 3
          If *Player\X + *Player\BlockX[i] = 0
            ProcedureReturn #False
          EndIf
          If *Player\BlockY[i] + *Player\Y >= 0
            If *Player\Player1(*Player\X + *Player\BlockX[i] -1, *Player\Y + *Player\BlockY[i],0)
              ProcedureReturn #False
            EndIf
          EndIf
        Next
      Case #PB_Right
        For i = 0 To 3
          If *Player\X + *Player\BlockX[i] = 9
            ProcedureReturn #False
          EndIf
          If *Player\BlockY[i] + *Player\Y >= 0
            If *Player\Player1(*Player\X + *Player\BlockX[i] +1, *Player\Y + *Player\BlockY[i],0)
              ProcedureReturn #False
            EndIf
          EndIf
        Next
      Case #PB_Down
        For i = 0 To 3
          If *Player\Y + *Player\BlockY[i] >= 0
            If *Player\Player1(*Player\X+*Player\BlockX[i],*Player\Y+ *Player\BlockY[i]+1,0) Or *Player\Y + *Player\BlockY[i] = 22
              ProcedureReturn #False
            EndIf
          EndIf
        Next
    EndSelect
    PlaySound(SndMove)
    ProcedureReturn #True
  EndProcedure
  
  Procedure CanRotate(*Player.Tetra,Rotation)
    If *Player\Type = 6
      ProcedureReturn #False
    EndIf
    Protected i,X,Y
    If *Player\Type = 3 Or *Player\Type = 4 Or *Player\Type = 0
      Rotation = 1
      Rotation ! *Player\Rotate
    EndIf
    If Rotation
      For i = 0 To 3
        X = - *Player\BlockY[i] + *Player\X : Y = *Player\BlockX[i] + *Player\Y
        If X > 9 : X = 9 : EndIf : If X < 0 : X = 0 : EndIf
        If Y < 0 : Y = 0 : EndIf : If Y > 22 : ProcedureReturn #False : EndIf
        If *Player\Player1(X,Y,0) : ProcedureReturn #False : EndIf
      Next
    Else
      For i = 0 To 3
        X = *Player\BlockY[i] + *Player\X : Y = - *Player\BlockX[i] + *Player\Y
        If X > 9 : X = 9 : EndIf : If X < 0 : X = 0 : EndIf
        If Y < 0 : Y = 0 : EndIf : If Y > 22 : ProcedureReturn #False : EndIf
        If *Player\Player1(X,Y,0) : ProcedureReturn #False : EndIf
      Next
    EndIf
    ProcedureReturn #True
  EndProcedure
  
  Procedure CalcGhost(*Player.Tetra)
    Protected PlayerY = *Player\Y
    *Player\GhostY = *Player\Y
    While CanMove(*Player,#PB_Down)
      *Player\Y + 1
    Wend
    *Player\GhostY = *Player\Y
    *Player\Y = PlayerY
  EndProcedure
  
  Procedure StickTetra(*Player.Tetra)
    Protected i
    PlaySound(SndStick)
    For i = 0 To 3
      *Player\Player1(*Player\X + *Player\BlockX[i], *Player\Y + *Player\BlockY[i],0) = *Player\Spr
      If *Player\X + *Player\BlockX[i] = 4 Or *Player\X + *Player\BlockX[i] = 5
        If *Player\Y + *Player\BlockY[i] = 2
          If PlayerMode = 2
            PureBF::MoveTextBox(LoserBox,*Player\DeltaX,*Player\DeltaY)
            If *Player = *TetraP1 : PureBF::MoveTextBox(WinnerBox,*TetraP2\DeltaX,*TetraP2\DeltaY) : Else : PureBF::MoveTextBox(WinnerBox,*TetraP1\DeltaX,*TetraP1\DeltaY) : EndIf
          EndIf
          MenuDeath = 0 : Menu::ChangeElement(MenuDeath,0)
          GameStat = #GS_Freez
          Effects::AddDeathEffect(*Player)
          ProcedureReturn #False
        EndIf
      EndIf
    Next
    ProcedureReturn #True
  EndProcedure
  
  Procedure NextTetra(*Player.Tetra)
    *Player\Type = *Player\Distrib()
    DeleteElement(*Player\Distrib(),#True)
    If ListSize(*Player\Distrib()) = 7
      GenerateDistribList(*Player)
    EndIf
    *Player\Spr = PeekI(@SprTetra+*Player\Type*SizeOf(integer))
    *Player\X = 4 : *Player\Y = 2
    *Player\Rotate = 0
    MakeTetra(*Player)    
    CalcGhost(*Player)
    If *Player\Inputs\Inputstate = 1
      *Player\Inputs\Inputstate = 2
    EndIf
  EndProcedure
  
  Procedure CheckFullRow(*Player.Tetra)
    Protected i,j,Result, skip, Size
    ClearList(*Player\FullRow())
    For i = 0 To 3
      skip = 0
      ForEach *Player\FullRow() 
        If *Player\Y + *Player\BlockY[i] = *Player\FullRow()
          skip = 1
          Break
        EndIf
      Next
      If skip : Continue : EndIf
      Result = 1
      For j = 0 To 9
        If *Player\Player1(j,*Player\Y + *Player\BlockY[i],0) = 0
          Result = 0 : Break
        EndIf
      Next
      If Result
        For j = 0 To 9
          *Player\Player1(j,*Player\Y + *Player\BlockY[i],0) = 0
        Next
        AddElement(*Player\FullRow())
        *Player\FullRow()= *Player\Y + *Player\BlockY[i]
      EndIf
    Next
    Size = ListSize(*Player\FullRow())
    If Size
      *Player\Line + Size
      If Size = 1 : *Player\Score + (40 *(*Player\level +1))
      ElseIf Size = 2 : *Player\Score + (100 *(*Player\level +1))
      ElseIf size = 3 : *Player\Score + (300 *(*Player\level +1))
      Else : *Player\Score + (1200 *(*Player\level +1)) : Effects::AddTetirsEffect(*Player) : EndIf
      If PlayerMode = 1
        PureBF::FreeTextBox(BoxLine)
        BoxLine = PureBF::CreateTextBox(300,340,160,60,#PB_Text_Right)
        PureBF::AddTextBoxString(BoxLine,Font,Str(*Player\Line),0.33,255)
        If *Player\Line / 10 > *Player\level
          *Player\level + 1
          PureBF::FreeTextBox(BoxLevel)
          BoxLevel = PureBF::CreateTextBox(300,440,160,60,#PB_Text_Right)
          PureBF::AddTextBoxString(BoxLevel,Font,Str(*Player\level),0.33,255)
          TempoP1 -50
        EndIf
      Else
        If *Player\Damage
          *Player\Damage - Round(Size * (*Player\Combo + 1),#PB_Round_Down)
          If *Player = *TetraP1
            Effects::AddFlyEffect(*Player,*TetraP1\DeltaX,200)
          Else
            Effects::AddFlyEffect(*Player,*TetraP2\DeltaX+200,-200)
          EndIf
          If *Player\Damage < 0
            *Player\Attaque + Abs(*Player\Damage)
            *Player\Damage = 0
          EndIf
        Else
          *Player\Attaque + Round(Size * (*Player\Combo +1),#PB_Round_Down)
        EndIf
        ;New attaque test
        If *Player\Attaque
          If *Player = *TetraP1
            *TetraP2\Damage + *TetraP1\Attaque
            *TetraP1\Attaque = 0
            Effects::AddFlyEffect(*Player,*TetraP1\DeltaX,*TetraP2\DeltaX- *TetraP1\DeltaX)
          Else
            *TetraP1\Damage + *TetraP2\Attaque
            *TetraP2\Attaque = 0
            Effects::AddFlyEffect(*Player,*TetraP2\DeltaX+200,*TetraP1\DeltaX - *TetraP2\DeltaX)
          EndIf
        EndIf
        ;end-------
        *Player\Combo + 0.2
      EndIf
      SortList(*Player\FullRow(),#PB_Sort_Descending)
      Effects::AddBreakEffect(*Player)
      *Player\Inputs\IgnoreInput = 1
    Else
      If *Player\Damage
        Attaque(*Player)
      EndIf
      *Player\Combo = 0
    EndIf
  EndProcedure
  
  Procedure BreakFullRow(*Player.Tetra)
    Protected LineToBreak, i,l, LastLine,StartLine,Delta
    ForEach *Player\FullRow()
      If LastLine
        If *Player\FullRow() = LastLine - 1 - Delta
          LastLine = *Player\FullRow() + Delta
          LineToBreak + 1
        Else
          For l = StartLine To LineToBreak Step -1
            For i = 0 To 9
              *Player\Player1(i,l,0) = *Player\Player1(i,l-LineToBreak,0)
            Next
          Next
          Delta = LineToBreak
          LastLine = *Player\FullRow()+Delta
          StartLine = LastLine
          LineToBreak = 1
        EndIf
      Else
        LastLine = *Player\FullRow()
        LineToBreak = 1
        StartLine = *Player\FullRow()
      EndIf
    Next
    For l = StartLine To LineToBreak Step -1
      For i = 0 To 9
        *Player\Player1(i,l,0) = *Player\Player1(i,l-LineToBreak,0)
      Next
    Next
    *Player\Inputs\IgnoreInput = 0
    CalcGhost(*Player)
  EndProcedure
  
  Procedure GenerateDistribList(*Player.Tetra)
    Protected NewList TempDistrib()
    CopyList(DistribModel(),TempDistrib())
    RandomizeList(TempDistrib())
    FirstElement(TempDistrib())
    MergeLists(TempDistrib(),*Player\Distrib())
    FreeList(TempDistrib())
  EndProcedure
  
  Procedure Hold(*Player.Tetra)
    Protected i
    If *Player\Hold = -1
    Protected Y = *Player\Y, X = *Player\X
      *Player\Hold = *Player\Type
      NextTetra(*Player)
      *Player\X = X : *Player\Y = Y
    Else
      Protected Hold = *Player\Hold
      *Player\Hold = *Player\Type
      *Player\Type = Hold
      MakeTetra(*Player)   
      *Player\Spr = PeekI(@SprTetra+*Player\Type*SizeOf(integer))
    EndIf
    For i = 0 To 3
      If *Player\X + *Player\BlockX[i] < 0 : *Player\X + 1 : Break : EndIf
      If *Player\X + *Player\BlockX[i] > 9 : *Player\X - 1 : Break : EndIf
    Next
    CalcGhost(*Player)
  EndProcedure
  
  Procedure Attaque(*Player.Tetra)
    Protected LoopX, LoopY, Damage, Kill,RndX
    If *Player\Damage >=4 : Damage = 4
    Else
      Damage = *Player\Damage
    EndIf
    For LoopY = 3 To 23
      RndX = Random(9)
      For LoopX = 0 To 9
        If LoopY <= Damage
          If *Player\Player1(LoopX,LoopY,0) : kill = 1 : EndIf
        EndIf
        If LoopY + Damage > 22
          If RndX = LoopX : *Player\Player1(LoopX,LoopY,0) = 0 : Continue : EndIf
          *Player\Player1(LoopX,LoopY,0) = SprTetra\Grey
        Else
          *Player\Player1(LoopX,LoopY,0) = *Player\Player1(LoopX,LoopY+Damage,0)
        EndIf
      Next
    Next
    Effects::AddAttaqueEffect(*Player)
    *Player\Damage - Damage
    If Kill
      PureBF::MoveTextBox(LoserBox,*Player\DeltaX,*Player\DeltaY)
      If *Player = *TetraP1 : PureBF::MoveTextBox(WinnerBox,*TetraP2\DeltaX,*TetraP2\DeltaY) : Else : PureBF::MoveTextBox(WinnerBox,*TetraP1\DeltaX,*TetraP1\DeltaY) : EndIf
      MenuDeath = 0 : Menu::ChangeElement(MenuDeath,0)
      GameStat = #GS_Freez
      Effects::AddDeathEffect(*Player)
    EndIf
  EndProcedure

  
EndModule
; IDE Options = PureBasic 5.70 LTS (Windows - x64)
; CursorPosition = 460
; FirstLine = 70
; Folding = BMBM+--------z4-+v-z-------
; EnableXP