﻿Module MainMenu
  Global NewList Menu.s(), LockUp, LockDown, TextBox
  AddElement(Menu()) : Menu() = "Play solo mode"
  AddElement(Menu()) : Menu() = "Play VS mode"
  AddElement(Menu()) : Menu() = "Options"
  AddElement(Menu()) : Menu() = "Credit"
  AddElement(Menu()) : Menu() = "Exit"
  
  Declare CheckInput()
  Declare MakeTextBox()
  
  Procedure Display()
    If TextBox = 0 : MakeTextBox() : EndIf
    Sprite3D::RenderSprite()
    PureBF::DisplayTextBox(TextBox)
    Menu::DisplayMenu(Menu(),850,450)
    ProcedureReturn CheckInput()
  EndProcedure
  
  Procedure CheckInput()
    Protected *Input.Input::InputStat
    *Input = Input::GetInput(0)
    If *Input\Up And LockUp = 0
      If menu : Menu - 1
        Menu::ChangeElement(Menu)
        MakeTextBox()
      EndIf
      LockUp = 1
    EndIf
    
    If *Input\Down And LockDown = 0
      If Menu < 4 : Menu + 1
        Menu::ChangeElement(Menu)
        MakeTextBox()
      EndIf
      LockDown = 1
    EndIf
    
    If *Input\Start And LockStart = 0
      Select Menu
        Case 0
          Function::PlayerMode = 1
          Function::initGame()
          PureBF::FreeTextBox(TextBox) : TextBox = 0
          ProcedureReturn 1
        Case 1
          Function::PlayerMode = 2
          Function::initGame()
          PureBF::FreeTextBox(TextBox) : TextBox = 0
          ProcedureReturn 1
        Case 2
          LockStart = 1
          ProcedureReturn 2
        Case 3
          LockStart = 1
          ProcedureReturn 3
        Case 4
          End
      EndSelect
    EndIf
    
    If *Input\Up = 0 : LockUp = 0 : EndIf
    If *Input\Down = 0 : LockDown = 0 : EndIf
    If *Input\Start = 0 : LockStart = 0 : EndIf
    ProcedureReturn #False
  EndProcedure
  
  Procedure MakeTextBox()
    If TextBox : PureBF::FreeTextBox(TextBox) : EndIf
    TextBox = PureBF::CreateTextBox(0,0,1280,500,#PB_Text_Center)
    Select Menu
      Case 0
        PureBF::AddTextBoxStringN(TextBox,Function::Font,"TETIRS 2",1,255)
        PureBF::AddTextBoxString(TextBox,Function::Font,"${wave} Classic mode",0.6,255)
      Case 1
        PureBF::AddTextBoxStringN(TextBox,Function::Font,"TETIRS 2",1,255)
        PureBF::AddTextBoxString(TextBox,Function::Font,"${wave} Versus mode",0.6,255)
      Case 2
        PureBF::AddTextBoxStringN(TextBox,Function::Font,"TETIRS 2",1,255)
        PureBF::SetShakeAttribut(1,10)
        PureBF::AddTextBoxString(TextBox,Function::Font,"${shake} Game & display setting",0.6,255)
      Case 3
        PureBF::AddTextBoxStringN(TextBox,Function::Font,"TETIRS 2",1,255)
        PureBF::AddTextBoxString(TextBox,Function::Font,"${blink} See credit",0.6,255)
      Case 4
        PureBF::AddTextBoxStringN(TextBox,Function::Font,"TETIRS 2",1,255)
        PureBF::SetShakeAttribut(1,1)
        PureBF::AddTextBoxString(TextBox,Function::Font,"${shake} Will you realy leave me ?",0.6,255)
    EndSelect
  EndProcedure
EndModule
; IDE Options = PureBasic 5.70 LTS (Windows - x64)
; CursorPosition = 55
; Folding = v+-
; EnableXP